var canvas;
var cntx;

function init(){
    canvas=document.getElementById("visualisation");
    cntx=canvas.getContext("2d");
    
    showAppTitle();
    initialValues();
    initialiseGUI();
    initialiseEvents();
    drawBasicScreen();
}
      
function initialiseEvents(){
    $("#visualisation").on("mousemove touchend",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseMove();
    });

    $("#visualisation").on("mouseup touchend",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseUp();
    });

    $("#visualisation").on("mousedown touchend",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseDown();
    });
} 

function initialiseGUI(){

}

function initialValues(){
    TitleTOP=20;
    TitleWIDTH=550;
    TitleLEFT=(width-TitleWIDTH)/2;
    TitleHEIGHT=35;
    imgLogo=document.getElementById("Logo");
    width=canvas.width;
    height=canvas.height;

    BottomPanelTop=height-BottomPanelHeight;
    logoLeft=width-logoWidth-5;
    logoTop=BottomPanelTop+(BottomPanelHeight-logoHeight)/2;
    imgNxtStepEnabled=document.getElementById("ButtonEnabledSmall");
    imgNxtStepSelected=document.getElementById("ButtonSelSmall");
    imgBackStepEnabled=document.getElementById("BackEnabledSmall");
    imgBackStepSelected=document.getElementById("BackSelSmall");
    nxtStepLeft=width-nxtStepWidth-15-logoWidth;
    nxtStepTop=BottomPanelTop+20;
    BackStepLeft=2;
    BackStepTop=nxtStepTop;
	imgToShowLeft=50;    
}

function drawBasicScreen(){
	getImagePixels();
	cntx.clearRect(0,0,canvas.width,canvas.height);
    //Φόντα οθόνης
    drawIntroImage();
    drawLogoImage();
    if(IntroStep<IntroLastStep) drawButtonNext();
    if(IntroStep>1) drawButtonBack();
	if(IntroStep==IntroLastStep-1) {
		drawPic(imgToShowLeft,imgToShowTop,imgToShowWidth,imgToShowHeight);
		var width2=4*imgToShowWidth/5;
		var height2=parseInt(imgToShowWidth*imgToShowHeight/width2);
		drawPic(imgToShowLeft+450,imgToShowTop,width2,height2);
	}
	if(IntroStep==IntroLastStep){
		$("#chkAutoRedraw").show(); 
		$("#lblAutoRedraw").show();
		$("#btnNewImage").show();
		$("#btnSolve").show();
		drawPic(imgToShowLeft,imgToShowTop,playingWidth,playingHeight);
		if(mouseResizing){
			drawUserBorder();
		}
	}
	else if(IntroStep==IntroLastStep-2){
		$("#hscrZoom").show();
		$("#chkShowGrid").show();
		$("#lblShowGrid").show();
		drawOrangePic(40,TopPanelHeight+30,orangePicWidth,orangePicHeight);
        cnvsWrite("rgb(0,0,200)",fontSize,"Arial",550,BottomPanelTop-10,""+orangePicWidth);
	}
	else{
		$("#hscrZoom").hide();
		$("#chkShowGrid").hide();
		$("#lblShowGrid").hide();
		$("#chkAutoRedraw").hide();
		$("#lblAutoRedraw").hide();
		$("#btnNewImage").hide();
		$("#btnSolve").hide();
	}    
    showUserPrompts();
}

function getImagePixels(){
	if(imgToShow){
		cntx.drawImage(imgToShow,imgToShowLeft,imgToShowTop);
		imgToShowPixels=cntx.getImageData(imgToShowLeft,imgToShowTop,imgToShow.width,imgToShow.height);
	}
}

function drawIntroImage(){
    Intro=document.getElementById("img"+IntroStep);
    var picTop=(height-Intro.height)/2;
    cntx.strokeStyle="black";
    //πλαίσιο καμβά
    cntx.rect(0,0,width,height);
    //άνω πλαίσιο
    cntx.rect(0,0,width,picTop-1);
    //κάτω πλαίσιο
    var lowRectTop=picTop+Intro.height+1;
    cntx.rect(0,lowRectTop,width,height-lowRectTop);

    cntx.stroke();
    cnvsWrite(LetterColor,35,"Arial",-1,TitleTOP+TitleHEIGHT,appTitle);
    cntx.drawImage(Intro,1,picTop);
}

function drawLogoImage(){
    var picTop=(height-Intro.height)/2;
    var lowRectTop=picTop+Intro.height+1;
    var logoTop=lowRectTop+((height-lowRectTop)-imgLogo.height)/2;
    cntx.drawImage(imgLogo,width-imgLogo.width-2,logoTop);
}

function showHTML(){
    window.open("index_DS_I_DS_II.html","_blank");
}

function drawButtonNext(){
    //Διαχείριση κουμπιού [Επόμενο Βήμα]
    if (buttonNextHover()){
        cntx.drawImage(imgNxtStepSelected,nxtStepLeft,nxtStepTop);
    }
    else{
        cntx.drawImage(imgNxtStepEnabled,nxtStepLeft,nxtStepTop);
    }
}

function buttonNextHover(){
    if (mx>=nxtStepLeft && mx<=nxtStepLeft+nxtStepWidth && my>=nxtStepTop && my<=nxtStepTop+nxtStepHeight){
        return true;
    }
    else {
        return false;
    }
}

function drawButtonBack(){
    //Διαχείριση κουμπιού [Επόμενο Βήμα]
    if (buttonBackHover()){
        cntx.drawImage(imgBackStepSelected,BackStepLeft,BackStepTop);
    }
    else{
        cntx.drawImage(imgBackStepEnabled,BackStepLeft,BackStepTop);
    }
}

function buttonBackHover(){
    if(mx>=BackStepLeft && mx<=BackStepLeft+BackStepWidth && my>=BackStepTop && my<=BackStepTop+BackStepHeight){
        return true;
    }
    else{
        return false;
    }
}

function cnvsWrite(clr,fontSize,fontName,txtX,txtY,txt){       
    cntx.font=fontSize+"px "+fontName;
    cntx.fillStyle=clr;
    if(txtX<0) txtX=(canvas.width-cntx.measureText(txt).width)/2;
    cntx.fillText(txt,txtX,txtY);
}

function handleMouseDown(){
	if(IntroStep==IntroLastStep){
		if(rightSideHover()){
			initMouseX=mx;
			mouseResizing=true;
		}
	}
}

function handleMouseMove(){
    if(mx>=logoLeft && mx<logoLeft+logoWidth && my>=logoTop && my<logoTop+logoHeight){
        imgLogo=document.getElementById("LogoSel");
    }
    else{
        imgLogo=document.getElementById("Logo");
    }
	if(IntroStep==IntroLastStep){
		if(mouseResizing){
			additionalWidth=mx-initMouseX;
			if($("#chkAutoRedraw").prop("checked")){
				playingWidth+=additionalWidth;
				calculatePlayingHeight();
				initMouseX=mx;
				additionalWidth=0;
			}
		    drawBasicScreen();
		}
		if(spinButtonsHover()){
			canvas.style.cursor="pointer";
		}
		else if(rightSideHover()){
			canvas.style.cursor="e-resize";
		}
		else{
			canvas.style.cursor="default";
		}
	}
	else{
	    drawBasicScreen();
	}
    //console.log("mx="+mx+" , my="+my);
}

function handleMouseUp(){
    if(mx>=logoLeft && mx<logoLeft+logoWidth && my >=logoTop && my<logoTop+logoHeight) {
        showHTML();
    }
    if(mx>=nxtStepLeft && mx<nxtStepLeft+nxtStepWidth && my>=nxtStepTop && my<nxtStepTop+nxtStepHeight && IntroStep<IntroLastStep && showNextStepButton()){
        IntroStep++;
		loadAppropriateImage();
    }
    if(mx>=BackStepLeft && mx<BackStepLeft+BackStepWidth && my>=BackStepTop && my<BackStepTop+BackStepHeight && IntroStep>1){
        IntroStep--;
		loadAppropriateImage();
    }

	if(IntroStep==IntroLastStep-2 && spinButtonsHover()){
		if(mx<521){
			decreaseOrangeWidth();
		}
		else{
			increaseOrangeWidth();
		}
	}
	if(IntroStep==IntroLastStep){
		if(spinButtonsHover()){
			if(my<173) {
				increaseWidth();
			}
			else{
				decreaseWidth();
			}
		}
		else if(mouseResizing){
			mouseResizing=false;
			playingWidth+=additionalWidth;
			calculatePlayingHeight();
			additionalWidth=0;
		}
	}
    drawBasicScreen();
}

function showNextStepButton(){
	return (IntroStep<IntroLastStep);
}

function showUserPrompts(){
    var vTxtOffset=15;
    var promptYCoord;
    promptYCoord=BottomPanelTop+15;
    if(IntroStep==IntroLastStep){
        cnvsWrite(LetterColor,fontSize,"Arial",70,promptYCoord,"Σύρε με το ποντίκι σου το δεξί άκρο της εικόνας για να αυξομειώσεις τις στήλες.");
        promptYCoord=promptYCoord+vTxtOffset;
        cnvsWrite(LetterColor,fontSize,"Arial",70,promptYCoord,"Οι γραμμές θα υπολογιστούν αυτόματα.");
        promptYCoord=promptYCoord+vTxtOffset;
        cnvsWrite(LetterColor,fontSize,"Arial",70,promptYCoord,"Κάνε κλικ στα βέλη για μικροδιορθώσεις.");
        promptYCoord=promptYCoord+vTxtOffset;
        cnvsWrite(LetterColor,fontSize,"Arial",70,promptYCoord,"Φόρτωσε μια διαφορετική εικόνα πατώντας το κουμπί [Αλλαγή εικόνας].");
        promptYCoord=promptYCoord+vTxtOffset;
        cnvsWrite(LetterColor,fontSize,"Arial",70,promptYCoord,"Αν ο υπολογιστής σου δεν είναι αρκετά γρήγορος, απενεργοποίησε την [Αυτόματη Επανασχεδίαση].");
		//Πληροφοριες εικόνας
		//backg.setFont(new Font("Dialog",Font.PLAIN,fontSize-6));
		//backg.setColor(new Color(0,0,200));
		//backg.drawString("Στήλες:"+PlayingWidth,appletWidth-120,440);
        cnvsWrite("rgb(0,0,200)",fontSize,"Arial",width-120,380,"Στήλες:"+playingWidth);
		//backg.drawString("Γραμμές:"+PlayingHeight,appletWidth-120,460);
        cnvsWrite("rgb(0,0,200)",fontSize,"Arial",width-120,400,"Γραμμές:"+playingHeight);
    }
    else if(IntroStep==IntroLastStep-2 && orangePicWidth==2*originalOrangePicWidth){
        cnvsWrite(LetterColor,fontSize,"Arial",70,promptYCoord,"Εμφανίστηκαν δύο όμοιες εικόνες!");
        promptYCoord=promptYCoord+vTxtOffset;
        cnvsWrite(LetterColor,fontSize,"Arial",70,promptYCoord,"Μπορείς να καταλάβεις πως έγινε αυτό;");
        promptYCoord=promptYCoord+vTxtOffset;
        cnvsWrite(LetterColor,fontSize,"Arial",70,promptYCoord,"(Παρατήρησε το ύψος τους...)");
    }
}

function loadPicToShow(){
	var randomSpectrum=0.3;
    var i=parseInt(Math.random()*44)+1;
    imgToShow=document.getElementById("p"+i);
    imgToShowWidth=imgToShow.width;
    imgToShowHeight=imgToShow.height;
	if(Math.random()<0.5){
		playingWidth=parseInt((Math.random()*randomSpectrum+1-randomSpectrum)*imgToShowWidth);
	}
	else {
		playingWidth=parseInt((Math.random()*randomSpectrum+1)*imgToShowWidth);
	}
	calculatePlayingHeight();
}

function changePicture(){
	loadPicToShow();
	drawBasicScreen();
}

function actionPerformed(slctr){
	if(slctr=="btnNewImage"){
		changePicture();
	}
	if(slctr=="btnSolve"){
		playingWidth=imgToShowWidth;
		playingHeight=imgToShowHeight;
		drawBasicScreen();
	}
}

function itemStateChanged(slctr){
	if(slctr=="chkAutoRedraw"){
		
	}
	else if(slctr=="chkShowGrid"){
		
	}
	drawBasicScreen();
}

function rangeValueChanged(slctr){
	if(slctr=="hscrZoom"){
		
	}
	drawBasicScreen();
}

function loadAppropriateImage(){
	if(IntroStep==IntroLastStep){
		loadPicToShow();
		imgToShowTop=TopPanelHeight+50;
	}
	else if(IntroStep==IntroLastStep-1){
		loadDemoPicToShow();
		imgToShowTop=TopPanelHeight+90;
	}
	else if(IntroStep==IntroLastStep-2){
		loadOrangePic();
	}
}

function spinButtonsHover(){
	if(IntroStep==IntroLastStep){
		return (mx>22 && mx<38 && my>155 && my<188);
	}
	else{
		return (mx>506 && mx<536 && my>498 && my<512);
	}
}

function rightSideHover(){
	var border=3;
	return (mx>imgToShowLeft+playingWidth-border && mx<imgToShowLeft+playingWidth+border && my>imgToShowTop && my<imgToShowTop+playingHeight);
}

function increaseWidth(){
	if(playingWidth<2*imgToShowWidth){
		playingWidth++;
		calculatePlayingHeight();
	}
}

function decreaseWidth(){
	if(playingWidth>1){
		playingWidth--;
		calculatePlayingHeight();
	}
}

function increaseOrangeWidth(){
	if(orangePicWidth<2*originalOrangePicWidth){
		orangePicWidth++;
		calculateOrangeHeight();
	}
}

function decreaseOrangeWidth(){
	if(orangePicWidth>originalOrangePicWidth){
		orangePicWidth--;
		calculateOrangeHeight();
	}
}

function calculateOrangeHeight(){
	orangePicHeight=parseInt(originalOrangePicWidth*originalOrangePicHeight/orangePicWidth);
}

function calculatePlayingHeight(){
	playingHeight=parseInt(imgToShowWidth*imgToShowHeight/playingWidth);
}

function loadDemoPicToShow(){
	imgToShow=document.getElementById("p16");
    imgToShowWidth=imgToShow.width;
    imgToShowHeight=imgToShow.height;
}

function loadOrangePic(){
	if(Math.random()>0.5){
		imgToShow=document.getElementById("orange1");
	}
	else{
		imgToShow=document.getElementById("orange2");
	}
	originalOrangePicWidth=imgToShow.width;
	originalOrangePicHeight=imgToShow.height;
	orangePicWidth=originalOrangePicWidth;
	orangePicHeight=originalOrangePicHeight;
}

function drawUserBorder(){
	var userWidth=playingWidth+additionalWidth;
	var userHeight=parseInt(imgToShowWidth*imgToShowHeight/userWidth);
	cntx.strokeStyle="rgb(255,0,0)";
	cntx.beginPath();
	cntx.rect(imgToShowLeft,imgToShowTop,userWidth,Math.min(userHeight,BottomPanelTop-imgToShowTop));
	cntx.stroke();
}

function drawPic(leftCoord,topCoord,widthToUse,heightToUse){
	var imgX,imgY,i,r,g,b;
	for(i=0;i<widthToUse*heightToUse;i++){
		r=imgToShowPixels.data[4*i];
		g=imgToShowPixels.data[4*i+1];
		b=imgToShowPixels.data[4*i+2];
		//if ((r>ColorLimit || g>ColorLimit || b>ColorLimit)){
			imgX=(i % widthToUse)+leftCoord;
			imgY=parseInt(i/widthToUse)+topCoord;
			if(imgY<BottomPanelTop){
				//backg.setColor(new Color(r,g,b));
				//backg.drawOval(imgX,imgY,1,1);
				cntx.fillStyle="rgb("+r+","+g+","+b+")";
				//cntx.beginPath();
				cntx.fillRect(imgX,imgY,1,1);
				//cntx.fill();
			}
		//}
	}
	//backg.setColor(new Color(0,0,0));
	cntx.strokeStyle="rgb(0,0,0)";
	//backg.drawRect(LeftCoord,TopCoord,WidthToUse,Math.min(HeightToUse,BottomPanelTop-1-TopCoord));
	cntx.beginPath();
	var calculatedHeight=Math.min(heightToUse,$("#controlsDiv1").position().top+$("#chkShowGrid").position().top-1-topCoord);
	cntx.rect(leftCoord,topCoord,widthToUse,calculatedHeight);
	cntx.stroke();
}

function drawOrangePic(leftCoord,topCoord,widthToUse,heightToUse){
	var zoom=parseInt($("#hscrZoom").val());
	var imgX,imgY,i,j,r,g,b;
	for(i=0;i<widthToUse*heightToUse;i++){
		r=imgToShowPixels.data[4*i];
		g=imgToShowPixels.data[4*i+1];
		b=imgToShowPixels.data[4*i+2];
		imgX=(i % widthToUse)*zoom+leftCoord;
		imgY=parseInt(i/widthToUse)*zoom+topCoord;
		if(imgY<BottomPanelTop){
			cntx.fillStyle="rgb("+r+","+g+","+b+")";
			cntx.beginPath();
			cntx.fillRect(imgX,imgY,zoom,zoom);
			cntx.fill();
		}
	}
	//backg.setColor(new Color(0,0,0));
	cntx.strokeStyle="rgb(0,0,0)";
	//backg.drawRect(LeftCoord,TopCoord,WidthToUse*hscrZoom.getValue(),Math.min(HeightToUse,chkShowGrid.getY()-1-TopCoord)*hscrZoom.getValue());
	cntx.beginPath();
	var calculatedHeight=Math.min(heightToUse,$("#controlsDiv1").position().top+$("#chkShowGrid").position().top-1-topCoord)*zoom;
	cntx.rect(leftCoord,topCoord,widthToUse*zoom,calculatedHeight);
	cntx.stroke();
	
	if($("#chkShowGrid").prop("checked") && zoom>2){
		for(i=0;i<widthToUse;i++){
			//backg.drawLine(LeftCoord+i*hscrZoom.getValue(),TopCoord,LeftCoord+i*hscrZoom.getValue(),TopCoord+HeightToUse*hscrZoom.getValue());
			cntx.beginPath();
			cntx.moveTo(leftCoord+i*zoom,topCoord);
			cntx.lineTo(leftCoord+i*zoom,topCoord+heightToUse*zoom);
			cntx.stroke();
		}
		for(j=0;j<heightToUse;j++){
			//backg.drawLine(leftCoord,topCoord+j*zoom,leftCoord+widthToUse*zoom,topCoord+j*zoom);
			cntx.beginPath();
			cntx.moveTo(leftCoord,topCoord+j*zoom);
			cntx.lineTo(leftCoord+widthToUse*zoom,topCoord+j*zoom);
			cntx.stroke();
		}
	}
}
